import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * The park is the setting for our White Blood Cell scenario. It's a place
 * where blood cells, steak and zookeeperes float around.
 * 
 * @author Michael Kölling
 * @version 1.0
 */
public class Park extends World
{
    private int score;
    private int time;
    
    /**
     * Constructor: Set up the staring objects.
     */
    public Park()
    {    
        super(575, 400, 1); 
        setPaintOrder(StoneWall.class);
        prepare();
        score = 0;
        time = 2000;
        showScore();
        showTime();
    }

    /**
     * Create new floating objects at irregular intervals.
     */
    public void act()
    {
        if (Greenfoot.getRandomNumber(100) < 3)
        {
            addObject(new Steak(), 779, Greenfoot.getRandomNumber(360));
        }
        
        // if (Greenfoot.getRandomNumber(100) < 1)
        // {
            // addObject(new Fence(), 779, 0);
        // }
        
        if (Greenfoot.getRandomNumber(100) < 1)
        {
            addObject(new Fence(), 779, 359);
        }
        
        if (Greenfoot.getRandomNumber(100) < 1)
        {
            addObject(new ZooKeeper(), 779, Greenfoot.getRandomNumber(360));
        }
        
        if (Greenfoot.getRandomNumber(100) < 2)
        {
            addObject(new Man(), 779, Greenfoot.getRandomNumber(360));
        }
        countTime();
    }
    
    /**
     * Add some points to our current score. (May be negative.)
     * If the score falls below 0, game's up.
     */
    
    
    /**
     * Show our current score on screen.
     */
    private void showScore()
    {
        showText("Score: " + score, 80, 25);
    }

    /**
     * Count down the game time and display it. Stop the game 
     * with a winning message when time is up.
     */
    private void countTime()
    {
        time--;
        showTime();
        if (time == 0)
        {
            showEndMessage();
            Greenfoot.stop();
        }
    }

    /**
     * Show the remaining game time on screen.
     */
    private void showTime()
    {
        showText("Time: " + time, 700, 25);
    }
    public void addScore(int points)
    {
    score = score + points;
    showScore();
    if (score < 0)
    {
    Greenfoot.playSound("game-over.wav");
    Greenfoot.stop();
    }
    }
    
    /**
     * Show the end-of-game message on screen.
     */
    private void showEndMessage()
    {
        showText("Time is up - you win!", 390, 150);
        showText("Your final score: " + score + " points", 390, 170);
    }
    
    /**
     * Prepare the world for the start of the program. In this case: Create
     * a white blood cell and the fence at the edge of the blood stream.
     */
    private void prepare()
    {
        Tiger tiger = new Tiger();
        addObject(tiger, 128, 179);

        Fence fence = new Fence();
        addObject(fence, 126, 1);
        Fence fence2 = new Fence();
        addObject(fence2, 342, 5);
        Fence fence3 = new Fence();
        addObject(fence3, 589, 2);
        Fence fence4 = new Fence();
        addObject(fence4, 695, 5);
        Fence fence5 = new Fence();
        addObject(fence5, 114, 359);
        Fence fence6 = new Fence();
        Fence fence7 = new Fence();
        addObject(fence7, 295, 353);
        Fence fence8 = new Fence();
        Fence fence9 = new Fence();
        Fence fence10 = new Fence();
        addObject(fence10, 480, 358);
        Fence fence11 = new Fence();
        addObject(fence11, 596, 359);
        Fence fence12 = new Fence();
        addObject(fence12, 740, 354);

        StoneWall border = new StoneWall();
        addObject(border, 0, 180);
        StoneWall border2 = new StoneWall();
        addObject(border2, 770, 180);
        removeObject(fence);
        removeObject(fence2);
        removeObject(fence3);
        removeObject(fence4);
    }
}
